<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 17/04/2015
 * Time: 10:36
 */

namespace Controller;

use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\File;
use \Util\Messages;
use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\Framework\DTO\Response\Error;


class Attachment extends Simple {

    private $attachmentService;

    public function __construct(\Service\Attachment $attachmentService ) {
        $this->attachmentService = $attachmentService;
    }

    public function saveLog(Request\DataSet $request, Response $response){
        try{
            $row = $request->getDataSet()->getRows();
            $row = $row[0];
            $subReleaseId = empty($row['subReleaseId']) ? null : $row['subReleaseId'] ;
            $releaseId = empty($row['releaseId']) ? null : $row['releaseId'] ;
            $deployId = empty($row['deployId']) ? null : $row['deployId'] ;
            $serverId = empty($row['serverId']) ? null : $row['serverId'] ;
            $document = empty($row['DOCUMENT'])? null :$row['DOCUMENT'];
            $this->attachmentService->saveLog($document, $subReleaseId, $releaseId, $deployId, $serverId);
            $response->addNotification( new Response\Notification('Todos os arquivos foram salvos'));
        }catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_WARNING));
        }
    }

    public function getFullLog(Request\Filter $request, Response $response)
    {
        $conditions = $request->getFilterCriteria()->getConditions();
        $logFileName = empty($conditions[0]) ? '' : $conditions[0]['value'];
        try {
            $logFileContents = $this->attachmentService->getFullLog($logFileName);
            $logFileContents = utf8_encode($logFileContents);   
            $response->addDataSet(new DataSet('logFileContents', [$logFileContents]));
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }
    
    public function sendLogByEmail(Request\Dataset $request, Response $response)
    {
        $row = $request->getDataSet()->getRows();
        $row = $row[0];
        try {
            $param = $row;
            $param['LOG_Email'] = empty($param['LOG_Email']) ? null : $param['LOG_Email'];
            $logFileContents = $this->attachmentService->getLogToSend($param['LOG_FILE_NAME']);
            if ($logFileContents != ""){
                $filename = $param['LOG_FILE_NAME'];
                $emails = explode(";", $param['LOG_Email']);
                $temp = Utilities::getTemporaryDir();
                $dir = $temp.DIRECTORY_SEPARATOR.$filename;
                $this->attachmentService->sendLogEmail($emails, $filename, $dir);
                $response->addDataSet(new DataSet('logFileContents', [$logFileContents]));  
            }
            
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    

    public function deleteAttachment(Request\DataSet $request, Response $response){
        try{
            $rows = $request->getDataSet()->getRows();
            $this->attachmentService->deleteAttachment($rows);

        }catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_WARNING));
        }
    }
} 